#pragma rtGlobals=1		// Use modern global access method.
#pragma version = 1.20
#pragma IgorVersion = 6.0
#pragma ModuleName=GZoomTrans
#include "GizmoUtility"

Static strConstant Q_UNITS_LIST = "1/nm;nm\\S-1\\M"


Static Function AfterFileOpenHook(refNum,file,pathName,type,creator,kind)
	Variable refNum, kind
	String file,pathName,type,creator
	if ((kind==1) || (kind==2))		// an experiment (packed or unpacked)
		InitGizmoZoomTranslate()
	endif
End
Static Function IgorStartOrNewHook(IgorApplicationNameStr)
	String IgorApplicationNameStr
	InitGizmoZoomTranslate()
End





// ****************************************************************
// ************************** Start of Cut Plane *************************

Function MakeGizmoCutPlanePanel() : Panel
	if (ItemsInList(WinList("GizmoCutPlanePanel",";","WIN:64")))
		DoWindow/F GizmoCutPlanePanel
		return 0
	endif

	Variable left=1094,top=245,width=150
	NewPanel/K=1/W=(left,top,left+width,top+160)/N=GizmoCutPlanePanel  as "Cut Plane"
	SetDrawLayer UserBack
	SetDrawEnv fstyle= 1
	DrawText 7,19,"Cut Plane (Gizmo)"
	SetDrawEnv linethick= 3
	DrawLine 0,98,150,98

	SetVariable cutValue,pos={10,24},size={114,19},bodyWidth=80,title="value",fSize=12
	SetVariable cutValue,proc=GZoomTrans#GizmoCutPlaneSetVarProc,value= _NUM:NaN
	PopupMenu popupXYZ title="cut plane",pos={10,48},size={102,20},proc=GZoomTrans#GizmoCutPlanePopMenuProc
	PopupMenu popupXYZ ,mode=1,fSize=12, value=#"\"+X;-X;+Y;-Y;+Z;-Z\""
	SetVariable xyzStep,pos={19,73},size={103,19},bodyWidth=70,proc=GZoomTrans#GizmoCutPlaneSetVarProc,title="xyz"
	SetVariable xyzStep,fSize=12,value= _NUM:1
	Button removeCutPlaneButton,pos={3,130},size={130,21},proc=GZoomTrans#GizmoCutPlaneButtonProc,title="remove cut plane"
	PopupMenu waveSelectPopup,pos={3,104},size={70,20},mode=1,value= #"\"\""
	SetWindow kwTopWin,hook(update)=GZoomTrans#GizmoCutPlanelUpdateHook
	return 0
End
//
Static Function GizmoCutPlanelUpdateHook(s)
	STRUCT WMWinHookStruct &s
	switch(s.eventCode)
		case 0:				// Activate
//		case 6:				// resize
//		case 12:			// moved
			GizmoCutPlanePanelUpdate()
			return 1
			break
		endswitch
	return 0		// 0 if nothing done, else 1
End
//
Static Function GizmoCutPlaneSetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	if (sva.eventCode!=1 && sva.eventCode!=2)	// mouse up and Enter key
		return 0
	endif

	if (stringmatch(sva.ctrlName,"xyzStep"))
		SetLimitsCutPlanePanel(sva.win)
	endif
	ReCalcCutPlaneFromPanel(sva.win)
	GizmoCutPlanePanelUpdate()
	return 0
End
//
Static Function GizmoCutPlanePopMenuProc(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa
	if (pa.eventCode != 2)		// break out if NOT mouse-up
		return 0
	endif

	SetLimitsCutPlanePanel(pa.win)
	ReCalcCutPlaneFromPanel(pa.win)
	return 0
End
//
Static Function GizmoCutPlaneButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	if (ba.eventCode != 2)	// mouse up event
		return 0
	elseif (itemsInList(WinList("*",";","WIN:4096"))<1)
		return 0
	elseif (!stringmatch(ba.ctrlName,"removeCutPlaneButton"))
		return 1
	endif

	ControlInfo/W=$(ba.win) waveSelectPopup
	Wave scatter=$S_Value
	if (!WaveExists(scatter))
		return 1
	endif

	ControlInfo/W=$(ba.win) removeCutPlaneButton
	String title = StringByKey("title", S_recreation,"=",",")
	title = ReplaceString("\"",title,"")
	if (stringmatch(title,"add cut plane*"))			// determine desired action
		Variable mid = SetLimitsCutPlanePanel(ba.win)
		ControlInfo/W=$(ba.win) cutValue
		if (numtype(V_Value))
			SetVariable cutValue, win=$(ba.win), value= _NUM:mid
		endif

		ReCalcCutPlaneFromPanel(ba.win)
	elseif (stringmatch(title,"remove cut plane*"))
		ApplyCutPlane2Triplets(scatter,0,0)
	endif

	GizmoCutPlanePanelUpdate()
	return 0
End
//
Static Function GizmoCutPlanePanelUpdate()
//	String list = GizmoListIsoSurfaceWaves()+GizmoListScatterWaves(), mstr="", str
	String list = GizmoListScatterWaves(), mstr="", str
	Variable i,N=ItemsInLIst(list)
	for (i=0;i<N;i+=1)
		str = StringFromLIst(i,list)
		str = StringFromLIst(0,str,"=")
		if (strlen(str))
			mstr += str+";"
		endif
	endfor
	mstr = "\""+mstr+"\""
	PopupMenu waveSelectPopup, value=#mstr
	ControlInfo/W=GizmoCutPlanePanel waveSelectPopup
	Wave scatter=$S_Value
	Variable plane=NumberByKey("cutPlane",note(scatter),"=")
	Variable value=NumberByKey("cutPlaneValue",note(scatter),"=")

	Variable displayed = numtype(plane+value)==0
	Variable dval = displayed ? 0 : 2
	SetVariable xyzStep,win=GizmoCutPlanePanel, disable=dval
	if (displayed)
		Button removeCutPlaneButton, win=GizmoCutPlanePanel, title="remove cut plane"
	else
		Button removeCutPlaneButton, win=GizmoCutPlanePanel, title="add cut plane"
	endif
	SetVariable cutValue, win=GizmoCutPlanePanel, disable=dval,value= _NUM:value

	Variable ip=round(abs(plane))-1
	if (ip>=0 && ip<=2)
		PopupMenu popupXYZ , win=GizmoCutPlanePanel, disable=dval, popvalue=SelectString(plane<0,"+","-")+StringFromList(ip,"X;Y;Z")
	endif

	return displayed
End
//
Static Function SetLimitsCutPlanePanel(win)
	String win					// panel window name

	ControlInfo/W=$win waveSelectPopup
	Wave scatter=$S_Value
	if (!WaveExists(scatter))
		return NaN
	endif

	ControlInfo/W=$win xyzStep
	Variable step = numtype(V_Value)==0 && V_Value>0 ? V_Value : NaN

	ControlInfo/W=$win popupXYZ
	Variable plane = str2planeNumber(S_Value)
	Variable ip = abs(plane)-1

	Variable dx=1, xLo=-inf, xHi=Inf, Nx
	if (WaveDims(scatter)==3)			// a 3D scaled xyz array
		dx = DimDelta(scatter,ip)
		Nx=DimSize(scatter,ip)
		xLo = DimOffset(scatter,ip)
		xHi = xLo + dx*(Nx-1)
		step = numtype(step) ? dx : step
	elseif (DimSize(scatter,1)==3)		// triplet xyz values
		String scatterName = GetWavesDataFolder(scatter,2)+"Orig"	// copy of original xyz, the backup
		if (exists(scatterName)==1)
			Wave scatter0=$scatterName		// contains original xyz, nothing cut off
		else
			Wave scatter0=scatter
		endif
		Variable N=DimSize(scatter0,0)
		Make/N=(N)/FREE xx
		xx = scatter0[p][ip]
		WaveStats/M=1/Q xx
		xLo = V_min
		xHi = V_max
		step = numtype(step) ? 1 : step
	else
		return NaN
	endif

	SetVariable cutValue, win=$win, limits={xLo,xHi,step}
	return (xLo+xHi)/2
End
//
Static Function ReCalcCutPlaneFromPanel(win)
	String win					// panel window name

	ControlInfo/W=$win waveSelectPopup
	Wave scatter=$S_Value

	ControlInfo/W=$win popupXYZ
	Variable plane = str2planeNumber(S_Value)
	ControlInfo/W=$win cutValue
	Variable value = V_Value
	if (!WaveExists(scatter) || numtype(value))
		return 1
	endif
	ApplyCutPlane2Triplets(scatter,plane,value)
	return 0
End
//
Static Function str2planeNumber(str)
	String str		// one of "X", "Y", "Z"
	str = ReplaceString("X",str,"1")
	str = ReplaceString("Y",str,"2")
	str = ReplaceString("Z",str,"3")

	Variable plane = str2num(str)
	plane = numtype(plane) ? 1 : round(plane)
	plane = limit(plane,-3,3)
	plane = plane ? plane : 1
	return plane
End


Static Function ApplyCutPlane2Triplets(xyz,plane,value)
	Wave xyz					// wave of xyz values
	Variable plane				// type of cut plane, 1=X, 2=Y, 3=Z,  0->reset to original
	Variable value				// value of cut plane

	if (!WaveExists(xyz))
		return 1
	elseif (WaveDims(xyz)!=2 || DimSize(xyz,0)<1 || DimSize(xyz,1)!=3)
		return 1
	endif

	String xyzName = GetWavesDataFolder(xyz,2)+"Orig"	// copy of original xyz, the backup
	if (!exists(xyzName))
		Duplicate xyz, $xyzName
	endif
	Wave xyz0=$xyzName		// contains original xyz, nothing cut off

	Variable ip=round(abs(plane))-1
	if (plane>0 && ip>=0 && ip<=2)
		xyz[][ip] = xyz0[p][ip]<=value ? xyz0[p][ip] : NaN
	elseif (plane<0 && ip>=0 && ip<=2)
		xyz[][ip] = xyz0[p][ip]>=value ? xyz0[p][ip] : NaN
	else
		xyz = xyz0				// re set to original values
		KillWaves/Z xyz0		// and get rid of the backup values
	endif

	String wnote=note(xyz)
	if (ip>=0 && ip<=2)
		wnote = ReplaceNumberByKey("cutPlane",wnote,plane,"=")
		wnote = ReplaceNumberByKey("cutPlaneValue",wnote,value,"=")
	else
		wnote = RemoveByKey("cutPlane", wnote,"=")
		wnote = RemoveByKey("cutPlaneValue", wnote,"=")
	endif
	Note/K xyz, wnote

	return 0
End

// ************************** End of Cut Plane **************************
// ****************************************************************


// ****************************************************************
// ************************** Start of Marker **************************

Function MakeGizmoScatterMarkerPanel() : Panel
	if (ItemsInList(WinList("GizmoScatterMarkerPanel",";","WIN:64")))
		DoWindow/F GizmoScatterMarkerPanel
		return 0
	endif

	Variable left=1094,top=245,width=150
	NewPanel/K=1/W=(left,top,left+width,top+340)/N=GizmoScatterMarkerPanel  as "Marker"
	SetDrawLayer UserBack
	SetDrawEnv fstyle= 1
	DrawText 7,19,"Scatter Marker (Gizmo)"
	SetDrawEnv fsize= 10
	DrawText 10,40,"absolute position"
	SetDrawEnv fsize= 10
	DrawText 10,152,"point to point"
	SetDrawEnv linethick= 3
	DrawLine 0,132,width,132
	SetDrawEnv linethick= 3
	DrawLine 0,231,width,231
	SetDrawEnv fsize= 10
	DrawText 10,251,"along wave"
	SetDrawEnv linethick= 3
	DrawLine 0,280,width,280

	SetVariable xyzStep,pos={19,108},size={103,19},bodyWidth=70,proc=GZoomTrans#GizmoScatterMarkerSetVarProc,title="xyz"
	SetVariable xyzStep,fSize=12,value= _NUM:1
	Button dXplusButtonPoint,pos={66,153},size={40,20}, proc=GZoomTrans#GizmoScatterMarkerButtonProc,title="+x"
	Button dXminusButtonPoint,pos={15,153},size={40,20}, proc=GZoomTrans#GizmoScatterMarkerButtonProc,title="-x"
	Button dYplusButtonPoint,pos={66,178},size={40,20}, proc=GZoomTrans#GizmoScatterMarkerButtonProc,title="+y"
	Button dYminusButtonPoint,pos={15,178},size={40,20}, proc=GZoomTrans#GizmoScatterMarkerButtonProc,title="-y"
	Button dZminusButtonPoint,pos={15,203},size={40,20}, proc=GZoomTrans#GizmoScatterMarkerButtonProc,title="-z"
	Button dZplusButtonPoint,pos={66,203},size={40,20}, proc=GZoomTrans#GizmoScatterMarkerButtonProc,title="+z"
	Button FitPeakButton,pos={111,153},size={35,40},proc=GZoomTrans#GizmoScatterMarkerButtonProc,title="Fit\rpeak"
	SetVariable alongWave,pos={10,255},size={124,19},bodyWidth=90,proc=GZoomTrans#GizmoScatterMarkerSetVarProc,title="point"
	SetVariable alongWave,fSize=12,limits={0,inf,1},value= _NUM:0
	Button removeMarkerButton,pos={17,313},size={110,21},proc=GZoomTrans#GizmoScatterMarkerButtonProc,title="remove marker"
	PopupMenu waveSelectPopup,pos={3,287},size={100,20}
	PopupMenu waveSelectPopup,mode=1,popvalue="",value=""
	SetVariable Xabsolute,pos={20,40},size={101,19},bodyWidth=90,title="X",fSize=12
	SetVariable Xabsolute,proc=GZoomTrans#GizmoScatterMarkerSetVarProc,value= _NUM:NaN
	SetVariable Yabsolute,pos={20,63},size={101,19},bodyWidth=90,title="Y",fSize=12
	SetVariable Yabsolute,proc=GZoomTrans#GizmoScatterMarkerSetVarProc,value= _NUM:NaN
	SetVariable Zabsolute,pos={20,86},size={101,19},bodyWidth=90,title="Z",fSize=12
	SetVariable Zabsolute,proc=GZoomTrans#GizmoScatterMarkerSetVarProc,value= _NUM:NaN

	ValDisplay IntensDisp,pos={12,340},size={109,17},title=" I",fSize=12			// Only show hkl & Intensity when a reciprocal lattice is present
	ValDisplay IntensDisp,limits={0,0,0},barmisc={0,1000},value= _NUM:0
	ValDisplay Hvaldisp,pos={12,360},size={109,17},title="H",fSize=12
	ValDisplay Hvaldisp,limits={0,0,0},barmisc={0,1000},value= _NUM:0
	ValDisplay Kvaldisp,pos={12,380},size={109,17},title="K",fSize=12
	ValDisplay Kvaldisp,limits={0,0,0},barmisc={0,1000},value= _NUM:0
	ValDisplay Lvaldisp,pos={12,400},size={109,17},title="L",fSize=12
	ValDisplay Lvaldisp,limits={0,0,0},barmisc={0,1000},value= _NUM:0

	SetWindow kwTopWin,hook(update)=GZoomTrans#GizmoScatterMarkerUpdateHook
	return 0
End


Function moveGizmoMarkerToPoint(point,scatter)	// used by external routines to move the marker
	Variable point
	Wave scatter

	if (!GizmoScatterMarkerDisplayed())
		return 1
	elseif (!WaveExists(scatter))
		return 1
	elseif (WaveDims(scatter)!=2 || DimSize(scatter,1)!=3)
		return 1
	elseif (!(point>=0 && point<DimSize(scatter,0)))
		return 1
	endif

	Wave marker=$GizmoGetScatterMarkerWave()
	if (!WaveExists(marker))
		return 1
	endif

	Variable mx=scatter[point][0], my=scatter[point][1], mz=scatter[point][2]
	if (numtype(mx+my+mz))
		// print "NaN"
	endif
	marker[0][0] = mx
	marker[0][1] = my
	marker[0][2] = mz
	GizmoScatterPanelUpdate()
	return 0
End


Static Function GizmoScatterMarkerSetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	if (sva.eventCode!=1 && sva.eventCode!=2)	// mouse up and Enter key
		return 0
	endif

	ControlInfo waveSelectPopup
	Wave scatter=$S_Value
	Variable dx=1, dy=1, dz=1, xLo=-inf,yLo=-inf,zLo=-inf, xHi=Inf,yHi=Inf,zHi=Inf, Nx,Ny,Nz
	if (WaveExists(scatter))
		if (WaveDims(scatter)==3)
			dx = DimDelta(scatter,0)
			dy = DimDelta(scatter,1)
			dz = DimDelta(scatter,2)
			Nx=DimSize(scatter,0)
			Ny=DimSize(scatter,1)
			Nz=DimSize(scatter,2)
			xLo = DimOffset(scatter,0)
			yLo = DimOffset(scatter,1)
			zLo = DimOffset(scatter,2)
			xHi = xLo + dx*(Nx-1)
			yHi = yLo + dy*(Ny-1)
			zHi = zLo + dz*(Nz-1)
		endif
	endif

	if (stringmatch(sva.ctrlName,"xyzStep"))
		ControlInfo xyzStep
		Variable step = V_Value
		SetVariable Xabsolute, limits={xLo,xHi,step}
		SetVariable Yabsolute, limits={yLo,yHi,step}
		SetVariable Zabsolute, limits={zLo,zHi,step}
	else
		step = min(min(abs(dx),abs(dy)),abs(dz))
		SetVariable xyzStep,value= _NUM:step
	endif

	Wave marker=$GizmoGetScatterMarkerWave()
	if (!WaveExists(marker) || numtype(sva.dval))
		return 1
	elseif (stringmatch(sva.ctrlName,"Xabsolute"))
		marker[0][0] = sva.dval
	elseif (stringmatch(sva.ctrlName,"Yabsolute"))
		marker[0][1] = sva.dval
	elseif (stringmatch(sva.ctrlName,"Zabsolute"))
		marker[0][2] = sva.dval
	elseif (stringmatch(sva.ctrlName,"alongWave"))
		if (!WaveExists(marker) || !WaveExists(scatter))
			return 1
		endif
		Variable i = sva.dval, N, mx,my,mz
		if (!(i>=0))
			return 1
		endif

		if (WaveDims(scatter)==2 && DimSize(scatter,1)==3)	// triplets
			N = DimSize(scatter,0)
			i = limit(i,0,N)
			mx = scatter[i][0]
			my = scatter[i][1]
			mz = scatter[i][2]
		else
			N = numpnts(scatter)
			i = limit(i,0,N)
			Variable ix = mod(i,Nx)
			Variable iy = mod(floor(i/Nx),Ny)
			Variable iz = floor(i/(Nx*Ny))
			mx = limit(ix*dx+xLo,xLo,xHi)
			my = limit(iy*dy+yLo,yLo,yHi)
			mz = limit(iz*dz+zLo,zLo,zHi)
		endif
		if (!(i>=0 && i<N))
			return 1
		endif
		marker[0][0] = mx
		marker[0][1] = my
		marker[0][2] = mz
		if (i!=sva.dval)
			SetVariable alongWave,value= _NUM:i
		endif
	endif
	GizmoScatterPanelUpdate()

	return 0
End
//
Static Function GizmoScatterMarkerButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	if (ba.eventCode != 2)	// mouse up event
		return 0
	elseif (itemsInList(WinList("*",";","WIN:4096"))<1)
		return 0
	endif

	Variable displayed=GizmoScatterPanelUpdate()
	Wave marker=$GizmoGetScatterMarkerWave()

	Variable anAdd=0
	if (stringmatch(ba.ctrlName,"removeMarkerButton"))
		ControlInfo removeMarkerButton
		String title = StringByKey("title", S_recreation,"=",",")
		title = ReplaceString("\"",title,"")
		if (stringmatch(title,"add marker*"))			// determine desired action
			anAdd = 1
		endif
	endif
	if (!WaveExists(marker) && !anAdd)
		return 0
	endif

	if (stringmatch(ba.ctrlName,"*ButtonPoint"))			// move marker 1 point in X, Y, or Z
		Variable mx=NaN,my=NaN,mz=NaN, point
		if (WaveExists(marker))
			mx = marker[0][0]
			my = marker[0][1]
			mz = marker[0][2]
		endif
		ControlInfo waveSelectPopup
		Wave scatter=$S_Value
		if (!WaveExists(scatter))
			Make/N=(2,3)/FREE scatter=NaN
			return NaN
		endif

		ControlInfo xyzStep
		Variable step = numtype(V_Value) ? 1 : V_Value
	endif

	if (stringmatch(ba.ctrlName,"dXminusButtonPoint"))		// move marker -step point in X
		point = GizmoScatterMarkerGetNearPoint(mx-step,my,mz)
		marker[0][0] = scatter[point][0]
	elseif (stringmatch(ba.ctrlName,"dXplusButtonPoint"))	// move marker +step point in X
		point = GizmoScatterMarkerGetNearPoint(mx+step,my,mz)
		marker[0][0] = scatter[point][0]
	elseif (stringmatch(ba.ctrlName,"dYminusButtonPoint"))	// move marker -step point in Y
		point = GizmoScatterMarkerGetNearPoint(mx,my-step,mz)
		marker[0][1] = scatter[point][1]
	elseif (stringmatch(ba.ctrlName,"dYplusButtonPoint"))	// move marker +step point in Y
		point = GizmoScatterMarkerGetNearPoint(mx,my+step,mz)
		marker[0][1] = scatter[point][1]
	elseif (stringmatch(ba.ctrlName,"dZminusButtonPoint"))	// move marker -step point in Z
		point = GizmoScatterMarkerGetNearPoint(mx,my,mz-step)
		marker[0][2] = scatter[point][2]
	elseif (stringmatch(ba.ctrlName,"dZplusButtonPoint"))	// move marker +step point in Z
		point = GizmoScatterMarkerGetNearPoint(mx,my,mz+step)
		marker[0][2] = scatter[point][2]

	elseif (stringmatch(ba.ctrlName,"FitPeakButton"))		// fit a 3D Gaussian peak at the marker position
		Wave scatterFit=$"", markerFit=$""
		ControlInfo/W=$(ba.win) waveSelectPopup
		Wave scatter=$S_Value
		if (WaveExists(scatter))
			if (WaveDims(scatter)==3)
				Wave scatterFit=scatter	
			endif
		endif
		if (WaveExists(marker))
			Wave markerFit=marker	
		endif
		FitPeakAt3Dmarker(scatterFit,markerFit,NaN,printIt=1)

	elseif (stringmatch(ba.ctrlName,"removeMarkerButton"))
		ControlInfo removeMarkerButton
		title = StringByKey("title", S_recreation,"=",",")
		title = ReplaceString("\"",title,"")
		if (stringmatch(title,"add marker*"))			// determine desired action
			GizmoAddScatterMarker()
		elseif (stringmatch(title,"remove marker*"))
			GizmoRemoveScatterMarker()
		endif
	endif

	GizmoScatterPanelUpdate()
	return 0
End
//
Static Function GizmoScatterMarkerUpdateHook(s)
	STRUCT WMWinHookStruct &s

	Variable hookResult = 0
	switch(s.eventCode)
		case 0:				// Activate
		case 6:				// resize
		case 12:			// moved
			GizmoScatterPanelUpdate()
			break
	endswitch
	return hookResult		// 0 if nothing done, else 1
End
//
Static Function GizmoScatterPanelUpdate()
	Variable displayed=GizmoScatterMarkerDisplayed()
	Variable dval = displayed ? 0 : 2

	SetVariable xyzStep,disable=dval

	Button dXplusButtonPoint,disable=dval
	Button dXminusButtonPoint,disable=dval
	Button dYplusButtonPoint,disable=dval
	Button dYminusButtonPoint,disable=dval
	Button dZminusButtonPoint,disable=dval
	Button dZplusButtonPoint,disable=dval
	Button FitPeakButton,disable=(dval? 1 : 0)
	SetVariable alongWave,disable=dval
	if (displayed)
		Button removeMarkerButton, title="remove marker"
	else
		Button removeMarkerButton, title="add marker"
	endif

	String list = GizmoListIsoSurfaceWaves()+GizmoListScatterWaves(), mstr="", str
	Variable i,N=ItemsInLIst(list)
	for (i=0;i<N;i+=1)
		str = StringFromLIst(i,list)
		str = StringFromLIst(0,str,"=")
		if (strlen(str))
			mstr += str+";"
		endif
	endfor
	mstr = "\""+mstr+"\""
	PopupMenu waveSelectPopup, value=#mstr

	Wave marker=$GizmoGetScatterMarkerWave()
	Variable mx=NaN,my=NaN,mz=NaN
	if (WaveExists(marker))
		mx = marker[0][0]
		my = marker[0][1]
		mz = marker[0][2]
	endif
	SetVariable Xabsolute,disable=dval,value= _NUM:mx
	SetVariable Yabsolute,disable=dval,value= _NUM:my
	SetVariable Zabsolute,disable=dval,value= _NUM:mz
	Variable point = GizmoScatterMarkerGetNearPoint(mx,my,mz)
	SetVariable alongWave,value= _NUM:point

	ControlInfo waveSelectPopup
	Wave scatter=$S_Value
	updatePanelHKL(scatter,mx,my,mz)
	if (dval==0)
		updatePanelXYZlimits(scatter)
	endif

	if (WaveDims(scatter)!=3)
		Button FitPeakButton,disable=1		// only show this button when marking a 3D wave
	endif
	return displayed
End


Static Function updatePanelXYZlimits(scatter)
	Wave scatter

	if (!WaveExists(scatter))
		return 1
	endif
	Variable dx=1, dy=1, dz=1, xLo=-inf,yLo=-inf,zLo=-inf, xHi=Inf,yHi=Inf,zHi=Inf, Nx,Ny,Nz
	if (WaveDims(scatter)==3)
		dx = DimDelta(scatter,0)
		dy = DimDelta(scatter,1)
		dz = DimDelta(scatter,2)
		Nx=DimSize(scatter,0)
		Ny=DimSize(scatter,1)
		Nz=DimSize(scatter,2)
		xLo = DimOffset(scatter,0)
		yLo = DimOffset(scatter,1)
		zLo = DimOffset(scatter,2)
		xHi = xLo + dx*(Nx-1)
		yHi = yLo + dy*(Ny-1)
		zHi = zLo + dz*(Nz-1)
		SetVariable xyzStep,disable=2
	else
		SetVariable xyzStep,disable=0
	endif
	SetVariable Xabsolute, limits={xLo,xHi,dx}
	SetVariable Yabsolute, limits={yLo,yHi,dy}
	SetVariable Zabsolute, limits={zLo,zHi,dz}
End


Static Function updatePanelHKL(scatter,qx,qy,qz)
	Wave scatter
	Variable qx,qy,qz

	if (!WaveExists(scatter) || numtype(qx+qy+qz))
		return 1
	elseif (WhichListItem(WaveUnits(scatter,0),Q_UNITS_LIST)<0)
		return 1
	endif
	Variable h=NaN,k=NaN,l=NaN
	String recip_lattice0=StringByKey("recip_lattice0",note(scatter),"=")

#if exists("str2recip")==6
	Wave RL = str2recip(recip_lattice0)
#else
	WAVE RL=$""
#endif
	if (WaveExists(RL))
		Make/N=3/D/FREE Qc={qx,qy,qz}
		MatrixOP/FREE hkl = Inv(RL) x Qc
		h=hkl[0]
		k=hkl[1]
		l=hkl[2]
	endif
	GetWindow/Z GizmoScatterMarkerPanel wsize
	if (V_flag)
		return 1
	endif

	Variable bottom=340
	if (numtype(h+k+l))
		MoveWindow/W=GizmoScatterMarkerPanel V_left, V_top, V_right, V_top+bottom
	else
		bottom += 80
		if (WaveDims(scatter)==3)
			Variable intens = scatter(qx)(qy)(qz)
			ValDisplay IntensDisp, disable=0, value= _NUM:intens
		else
			ValDisplay IntensDisp disable=1
		endif
		ValDisplay Hvaldisp,value= _NUM:h
		ValDisplay Kvaldisp,value= _NUM:k
		ValDisplay Lvaldisp,value= _NUM:l
		MoveWindow/W=GizmoScatterMarkerPanel V_left, V_top, V_right, V_top+bottom
	endif
	return 0
End


Static Function/T GizmoAddScatterMarker([rgba,alpha])		// adds marker to gizmo if needed, will also create the marker wave if needed
	String rgba					// red, green, blue, or "" is black, or you can give your own rgba as "1,1,0,0.5"
	Variable alpha
	rgba = SelectString(ParamIsDefault(rgba),rgba,"")
	alpha = ParamIsDefault(alpha) ? NaN : alpha

	Execute "ModifyGizmo stopRotation"
	String wname=GizmoGetScatterMarkerWave()
	if (strlen(wname)<1)							// not in object list, add it
		Wave gizmoScatterMarker=gizmoScatterMarker
		if (!WaveExists(gizmoScatterMarker))
			Make/N=(1,3) gizmoScatterMarker
		endif

		String CrossObject=AddGizmoMarkerGroup("CrossPathGroup", rgba=rgba,alpha=alpha)

		Execute "ModifyGizmo startRecMacro"
		Execute "AppendToGizmo Scatter="+GetWavesDataFolder(gizmoScatterMarker,2)+",name=scatterMarker0"
		Execute "ModifyGizmo ModifyObject=scatterMarker0 property={ scatterColorType,0}"
		Execute "ModifyGizmo ModifyObject=scatterMarker0 property={ markerType,0}"
		Execute "ModifyGizmo ModifyObject=scatterMarker0 property={ sizeType,0}"
		Execute "ModifyGizmo ModifyObject=scatterMarker0 property={ rotationType,0}"
//		Execute "ModifyGizmo ModifyObject=scatterMarker0 property={ Shape,14}"		// for a sphere
//		Execute "ModifyGizmo ModifyObject=scatterMarker0 property={ size,0.3}"
		Execute "ModifyGizmo ModifyObject=scatterMarker0 property={ Shape,7}"
		Execute "ModifyGizmo ModifyObject=scatterMarker0 property={ size,0.5}"
		Execute "ModifyGizmo ModifyObject=scatterMarker0 property={ objectName,"+CrossObject+"}"
		Execute "ModifyGizmo ModifyObject=scatterMarker0 property={ color,0,0,0,.5}"
		Execute "ModifyGizmo endRecMacro"
		wname = GetWavesDataFolder(gizmoScatterMarker,2)
	endif

	Execute "GetGizmo displayItemExists=scatterMarker0"
	if (!NumVarOrDefault("V_Flag",1))				// object not in display list, add it before other objects
		Execute "GetGizmo displayList"				// list of all displayed objects
		Wave/T TW_DisplayList=TW_DisplayList
		Variable i,N=DimSize(TW_DisplayList,0)
		for (i=N-1;i>=0;i-=1)
			if (strsearch(TW_DisplayList[i],"ModifyGizmo setDisplayList="+num2istr(i)+", object",0)<0)
				i += 1
				break
			endif
		endfor
		if (i>=0)									// position it before other objects
			Execute "ModifyGizmo insertDisplayList="+num2istr(i)+", object=scatterMarker0"
		else											// just put it at end
			Execute "ModifyGizmo setDisplayList=-1, object=scatterMarker0"
		endif
	endif

	return wname
End
//
Static Function GizmoRemoveScatterMarker()		// removes marker from gizmo if needed, it does not remove it from the object list
	Execute "ModifyGizmo stopRotation"
	Execute "GetGizmo displayItemExists=scatterMarker0"
	NVAR V_flag=V_flag
	if (V_flag)										// object not in display list, remove it
		Execute "RemoveFromGizmo displayItem=scatterMarker0"
	endif
End
//
Static Function GizmoScatterMarkerDisplayed()			// returns true if scatter marker is displayed
	Execute "GetGizmo displayItemExists=scatterMarker0"
	NVAR V_Flag=V_Flag
	return V_Flag
End
//
Static Function/T GizmoGetScatterMarkerWave()	// gets name of wave with position of scatter marker
	String wname=""

	Execute "ModifyGizmo stopRotation"
	Execute "GetGizmo objectItemExists=scatterMarker0"
	NVAR V_Flag=V_Flag
	if (!V_Flag)									// not in object list, so stop here
		return ""
	endif

	Execute "GetGizmo objectList"					// find name of wave with marker position
	String str
	Wave/T TW_gizmoObjectList
	Variable i,i0,i1
	for (i=0;i<numpnts(TW_gizmoObjectList);i+=1)
		str = TW_gizmoObjectList[i]
		if (strsearch(str,"AppendToGizmo Scatter=",0)>=0 && strsearch(str,"name=scatterMarker0",0)>0)
			i0 = strsearch(str,"=",0)+1
			i1 = strsearch(str,",name=scatterMarker0",0)-1
			wname = str[i0,i1]
			break
		endif
	endfor
	KillWaves/Z TW_gizmoObjectList
	KIllStrings/Z S_gizmoObjectList

	return wname
End
//
//Static Function/T GizmoListScatterWaves()			// get list of all scatter plots, except 'scatterMarker0'
//	Execute "ModifyGizmo stopRotation"
//	Execute "GetGizmo displayList"					// list of all displayed objects
//	Execute "GetGizmo objectList"					// find name of wave with marker position
//	Wave/T TW_DisplayList=TW_DisplayList, TW_gizmoObjectList=TW_gizmoObjectList
//
//	String keyList=""
//	String str, wname, list, scatterName
//	Variable i,i0,i1
//	for (i=0;i<numpnts(TW_gizmoObjectList);i+=1)
//		str = TW_gizmoObjectList[i]
//
//		i0 = strsearch(str,"AppendToGizmo ",0)
//		if (i0<0 || i0>1)							// only process AppendToGizmo commands
//			continue
//		endif
//		list = str[i0+strlen("AppendToGizmo "),Inf]
//
//		scatterName = StringByKey("name",list,"=",",")
//		if (stringmatch(scatterName,"scatterMarker0"))	// skip scatterMarker0
//			continue
//		endif
//
//		wname = StringByKey("Scatter",list,"=",",")
//		if (strlen(wname)<1)
//			continue
//		endif
//		keyList = ReplaceStringByKey(wname,keyList,scatterName,"=")
//	endfor
//	KillWaves/Z TW_DisplayList, TW_gizmoObjectList
//	KIllStrings/Z S_DisplayList, S_gizmoObjectList
//	return keyList
//End
//
//Static Function/T GizmoListIsoSurfaceWaves()		// get list of all iso surface waves
//	Execute "ModifyGizmo stopRotation"
//	Execute "GetGizmo displayList"					// list of all displayed objects
//	Execute "GetGizmo objectList"					// find name of wave with marker position
//	Wave/T TW_DisplayList=TW_DisplayList, TW_gizmoObjectList=TW_gizmoObjectList
//
//	String keyList=""
//	String str, wname, list, scatterName
//	Variable i,i0,i1
//	for (i=0;i<numpnts(TW_gizmoObjectList);i+=1)
//		str = TW_gizmoObjectList[i]
//
//		i0 = strsearch(str,"AppendToGizmo ",0)
//		if (i0<0 || i0>1)							// only process AppendToGizmo commands
//			continue
//		endif
//		list = str[i0+strlen("AppendToGizmo "),Inf]
//
//		scatterName = StringByKey("name",list,"=",",")
//		wname = StringByKey("isoSurface",list,"=",",")
//		if (strlen(wname)<1)
//			continue
//		endif
//		keyList = ReplaceStringByKey(wname,keyList,scatterName,"=")
//	endfor
//	KillWaves/Z TW_DisplayList, TW_gizmoObjectList
//	KIllStrings/Z S_DisplayList, S_gizmoObjectList
//	return keyList
//End
//
Static Function GizmoScatterMarkerGetNearPoint(mx,my,mz)
	Variable mx, my, mz
	if (numtype(mx+my+mz))
		return NaN
	endif

	ControlInfo waveSelectPopup
	Wave scatter=$S_Value
	if (!WaveExists(scatter))
		return NaN
	endif

	if (WaveDims(scatter)==2 && DimSize(scatter,1)==3)	// a triplet scatter wave
		Variable N=DimSize(scatter,0)
		Make/N=(N)/FREE delta
		delta = (scatter[p][0]-mx)^2 + (scatter[p][1]-my)^2 + (scatter[p][2]-mz)^2
		WaveStats/M=1/Q delta
		return V_minloc

	elseif (WaveDims(scatter)==3)							// a scaled 3d wave
		Variable ix,iy,iz
		Variable Nx=DimSize(scatter,0), Ny=DimSize(scatter,1), Nz=DimSize(scatter,2)
		ix = round( (mx-DimOffset(scatter,0)) / DimDelta(scatter,0) )
		iy = round( (my-DimOffset(scatter,1)) / DimDelta(scatter,1) )
		iz = round( (mz-DimOffset(scatter,2)) / DimDelta(scatter,2) )
		ix = limit(ix,0,DimSize(scatter,0)-1)
		iy = limit(iy,0,DimSize(scatter,1)-1)
		iz = limit(iz,0,DimSize(scatter,2)-1)
		return (iz*Nx*Ny) + iy*Nx + ix
	endif
	return NaN
End





Function FitPeakAt3Dmarker(space3D,Qc,QxHW,[QyHW,QzHW,printIt])
	Wave space3D
	Wave Qc					// center of sub-volume to fit
	Variable QxHW,QyHW,QzHW	// half widths dQz, dQy, dQz for the sub volume
	Variable printIt

	printIt = ParamIsDefault(printIt) ? 0 : !(!printIt)
	QyHW = ParamIsDefault(QyHW) ? NaN : QyHW	// QyHW & QzHW default to QwhX
	QzHW = ParamIsDefault(QzHW) ? NaN : QzHW
	if (WaveExists(space3D))
		if (WaveDims(space3D)!=3)
			return 1						// quit if really bad input passed
		endif
	endif
	if (WaveExists(Qc))
		if (numpnts(Qc)!=3)
			return 1						// quit if really bad input passed
		endif
	endif
	String spaceList = WaveListClass("GizmoXYZ;Qspace3D*","*","DIMS:3")
	if (!WaveExists(space3D))				// no space3D passed
		if (ItemsInList(spaceList)==1)		// only 1 choice, use it
			Wave space3D = $StringFromList(0,spaceList)
		elseif (ItemsInList(spaceList)<1)	// no acceptable choices, quit
			return 1
		endif
	endif
	String QcList=WaveList("*",";","DIMS:2,MAXROWS:1,MINROWS:1,MAXCOLS:3,MINCOLS:3" )+WaveList("*",";","DIMS:1,MAXROWS:3,MINROWS:3" )
	if (!WaveExists(Qc))					// no Qc passed
		if (ItemsInList(QcList)==1)		// only 1 choice, use it
			Wave Qc = $StringFromList(0,QcList)
		elseif (ItemsInList(QcList)<1)		// no acceptable choices, quit
			return 1
		endif
	endif

	if (!WaveExists(space3D) || !WaveExists(Qc) || !(QxHW>0))
		printIt = 1
		String QcName=NameOfWave(Qc), spaceName = NameOfWave(space3D)
		QcName = SelectString(strlen(QcName),"gizmoScatterMarker",QcName)
		QxHW = QxHW>0 ? QxHW : 1
		Prompt spaceName,"3D space",popup,spaceList
		Prompt QcName,"Center of 3D space",popup,QcList
		Prompt QxHW,"X-HW in Volume to Use"
		Prompt QyHW,"Y-HW in Volume to Use (NaN defaults to X-HW)"
		Prompt QzHW,"Z-HW in Volume to Use (NaN defaults to X-HW)"
		DoPrompt "Fit 3D Peak",spaceName,QcName,QxHW,QyHW,QzHW
		if (V_flag)
			return 1
		endif
		printf "FitPeakAt3Dmarker(%s, %s, %g",spaceName,QcName,QxHW
		if (QyHW>0)
			printf ", QyHW=%g",QyHW
		endif
		if (QzHW>0)
			printf ", QzHW=%g",QzHW
		endif
		printf ")\r"
		Wave space3D=$spaceName
		Wave Qc=$QcName
	endif
	QyHW = QyHW>0 ? QyHW : QxHW
	QzHW = QzHW>0 ? QzHW : QxHW
	if (!WaveExists(space3D) || !WaveExists(Qc) || !(QxHW>0) || !(QyHW>0) || !(QzHW>0))
		return 1
	endif

	Make/N=3/D/FREE Qhw={QxHW,QyHW,QzHW}	// half widths dQz, dQy, dQz for the sub volume
	if (!WaveExists(space3D) || !WaveExists(Qc))
		return 1
	elseif (numtype(sum(Qhw)+sum(Qc)))
		return 1
	endif

	Make/N=3/D/FREE Qlo, Qhi, iLo,iHi,Np
	Qlo = Qc[p]-Qhw[p]
	Qhi = Qc[p]+Qhw[p]
	Np = DimSize(space3D,p)
	iLo = (Qlo[p]-DimOffSet(space3D,p))/DimDelta(space3D,p)
	iHi = (QHi[p]-DimOffSet(space3D,p))/DimDelta(space3D,p)
	iLo = limit(floor(iLo),0,Np)
	iHi = limit(ceil(iHi),0,Np)
	Np = iHi[p]-iLo[p]+1
	if (0 && printIt)
		printWave(Qlo,Name="Qlo")
		printWave(Qhi,Name="Qhi")
		printWave(iLo,Name="iLo")
		printWave(iHi,Name="iHi")
		printWave(Np,Name="Np")
	endif
	if (WaveMin(Np)<=0)
		return 1
	endif
	Make/N=(Np[0],Np[1],Np[2])/FREE/D sub3D
	sub3D = space3D[iLo[0]+p][iLo[1]+q][iLo[2]+r]
	SetScale/P x, iLo[0]*DimDelta(space3D,0)+DimOffset(space3D,0), DimDelta(space3D,0),"",sub3D
	SetScale/P y, iLo[1]*DimDelta(space3D,1)+DimOffset(space3D,1), DimDelta(space3D,1),"",sub3D
	SetScale/P z, iLo[2]*DimDelta(space3D,2)+DimOffset(space3D,2), DimDelta(space3D,2),"",sub3D

	// set the starting point for the fit
	Variable maxVal=WaveMax(sub3D),minVal=WaveMin(sub3D)
	Make/N=8/D/O W_coef = {NaN,NaN,Qc[0],Qhw[0]/4,Qc[1],Qhw[1]/4,Qc[2],Qhw[2]/4}
	if (maxVal>-minVal)			// a positive peak
		W_coef[1] = maxVal
		W_coef[0] = minVal==0 ? 1 : minVal
	else								// a negative peak
		W_coef[1] = minVal
		W_coef[0] = maxVal==0 ? 1 : maxVal
	endif
	FuncFitMD/Q GZoomTrans#Gaussian3DFitFunc, W_coef, sub3D

	if (printIt)
		Make/N=3/D/FREE Qo=W_coef[2*p + 2]
		Make/N=3/T/FREE units=WaveUnits(space3D,p)
		units = SelectString(stringmatch(units[p],"nm\\S-1*"),units[p],"1/nm")		// two different ways of writing 1/nm
		units = SelectString(strlen(units[p]),""," ("+units[p]+")")					// add () when something present
		Make/N=3/T/FREE Qstr=SelectString(strsearch(units[p],"1/nm",0)>=0,"","Q")// is it Q?
		Wave W_sigma=W_sigma, W_coef=W_coef
		printf "Gaussian Fit has offset = %s,  amp = %s\r",ValErrStr(W_coef[0],W_sigma[0],sp=1),ValErrStr(W_coef[1],W_sigma[1],sp=1)
		printf "  <%sx> = %s%s,   FWHMx = %s%s\r",Qstr[0],ValErrStr(Qo[0],W_sigma[2],sp=1),units[0],ValErrStr(W_coef[3],W_sigma[3],sp=1),units[0]
		printf "  <%sy> = %s%s,   FWHMy = %s%s\r",Qstr[1],ValErrStr(Qo[1],W_sigma[4],sp=1),units[1],ValErrStr(W_coef[5],W_sigma[5],sp=1),units[1]
		printf "  <%sz> = %s%s,   FWHMz = %s%s\r",Qstr[2],ValErrStr(Qo[2],W_sigma[6],sp=1),units[1],ValErrStr(W_coef[7],W_sigma[7],sp=1),units[2]
		if (stringmatch(units[0],units[1]) && stringmatch(units[0],units[2]))
			Variable Qmag=norm(Qo), dQmag=sqrt(W_sigma[2]^2 + W_sigma[4]^2 + W_sigma[6]^2)
			printf "  <|%s|> = %s%s\r",Qstr[0],ValErrStr(Qmag,dQmag,sp=1),units[0]
		endif
		if (WaveDims(space3D)==3)
			Np = DimSize(space3D,p)
			Make/N=3/D/FREE ijk
			ijk = (Qo[p]-DimOffset(space3D,p)) / DimDelta(space3D,p)
			ijk = limit(round(ijk[p]),0,Np[p]-1)
			Variable i=ijk[0], j=ijk[1], k=ijk[2]
			Variable N = k*Np[0]*Np[1] + j*Np[0] + i
			printf "  Closest point to peak is the %s[%g, %g, %g] or [%d] = %g\r",NameOfWave(space3D),i,j,k,N,space3D[i][j][k]
		endif

		Wave hkl=$""
#if exists("diffractometer#sample2crystal")
		STRUCT sampleStructure sa	
		String str = ParseFilePath(1,GetWavesDataFolder(space3D,1),":",1,0)+"sampleStructStr"
		String strStruct=StrVarOrDefault(str,"")						// fill the sample structure with values in spec scan directory
		StructGet/S/B=2 sa, strStruct									// found structure information, load into s
		Wave hkl = diffractometer#sample2crystal(sa,Qo)			// rotate qvec from sample-location frame into crystal based frame, the hkl
#endif
#if exists("str2recip")
		if (!WaveExists(hkl))
			String recip_lattice0=StringByKey("recip_lattice0",note(space3D),"=")
			Wave RL = str2recip(recip_lattice0)
			if (WaveExists(RL))
				MatrixOP/FREE hkl = Inv(RL) x Qo
			endif
		endif
#endif
		if (WaveExists(hkl))
			printf "hkl Center = %s\r",vec2str(hkl)
		endif
	endif
	return 0
End
//
Static Function Gaussian3DFitFunc(w,xx,yy,zz) : FitFunc
	Wave w
	Variable xx
	Variable yy
	Variable zz

	//CurveFitDialog/ These comments were created by the Curve Fitting dialog. Altering them will
	//CurveFitDialog/ make the function less convenient to work with in the Curve Fitting dialog.
	//CurveFitDialog/ Equation:
	//CurveFitDialog/ Variable ss = ((xx-x0)/xFWHM)^2 + ((yy-y0)/yFWHM)^2 + ((zz-z0)/zFWHM)^2
	//CurveFitDialog/ ss *= 4*ln(2)
	//CurveFitDialog/ ss = max(-500,ss)
	//CurveFitDialog/ f(xx,yy,zz) = offset + amp*exp(-ss)
	//CurveFitDialog/ End of Equation
	//CurveFitDialog/ Independent Variables 3
	//CurveFitDialog/ xx
	//CurveFitDialog/ yy
	//CurveFitDialog/ zz
	//CurveFitDialog/ Coefficients 8
	//CurveFitDialog/ w[0] = offset
	//CurveFitDialog/ w[1] = amp
	//CurveFitDialog/ w[2] = x0
	//CurveFitDialog/ w[3] = xFWHM
	//CurveFitDialog/ w[4] = y0
	//CurveFitDialog/ w[5] = yFWHM
	//CurveFitDialog/ w[6] = z0
	//CurveFitDialog/ w[7] = zFWHM

	Variable ss = ((xx-w[2])/w[3])^2 + ((yy-w[4])/w[5])^2 + ((zz-w[6])/w[7])^2
	ss *= 4*ln(2)
	ss = max(-500,ss)
	return w[0] + w[1]*exp(-ss)
End

// ************************** End of Marker ***************************
// ****************************************************************


// ****************************************************************
// *********************** Start of Zoom/Translate ***********************

Function MakeGizmoZoomTransPanel() : Panel
	if (ItemsInList(WinList("GizmoZoomTransPanel", ";", "WIN:64")))
 		DoWindow/F GizmoZoomTransPanel
		return 0
	endif
	NewDataFolder/O root:Packages
	NewDataFolder/O root:Packages:GizmoZoomTranslate

	NewPanel/K=1/W=(1094,50,1250,220)/N=GizmoZoomTransPanel  as "for Gizmo"
	SetDrawLayer UserBack
	SetDrawEnv fstyle= 1
	DrawText 7,19,"Zoom & Translate Gizmo"
	SetVariable zoomVal,pos={18,25},size={101,19},bodyWidth=65,proc=GZoomTrans#GizmoZoomTranslateSetVarProc,title="zoom"
	SetVariable zoomVal,fSize=12,limits={1e-12,inf,0.1},value= _NUM:1
	SetVariable xTranslate,pos={21,50},size={90,19},bodyWidth=70,proc=GZoomTrans#GizmoZoomTranslateSetVarProc,title="X"
	SetVariable xTranslate,fSize=12,value= _NUM:0
	SetVariable yTranslate,pos={21,73},size={90,19},bodyWidth=70,proc=GZoomTrans#GizmoZoomTranslateSetVarProc,title="Y"
	SetVariable yTranslate,fSize=12,value= _NUM:0
	SetVariable zTranslate,pos={21,95},size={90,19},bodyWidth=70,proc=GZoomTrans#GizmoZoomTranslateSetVarProc,title="Z"
	SetVariable zTranslate,fSize=12,value= _NUM:0
	Button autoButton,pos={28,120},size={90,20},proc=GZoomTrans#GizmoZoomTransButtonProc,title="full scale"
	Button cubifyButton,pos={28,143},size={90,20},proc=GZoomTrans#GizmoZoomTransButtonProc,title="cubify"
	SetWindow GizmoZoomTransPanel hook(update)=GZoomTrans#GizmoZoomTranslateUpdateHook
	return 0
End

Function showBox()
	if (itemsInList(WinList("*",";","WIN:4096"))==0)
		return 1
	endif

	String fldrSav= GetDataFolder(1)
	SetDataFolder root:Packages:GizmoZoomTranslate
	Execute "GetGizmo userBoxLimits"
	NVAR GizmoBoxXmin=GizmoBoxXmin, GizmoBoxXmax=GizmoBoxXmax
	NVAR GizmoBoxYmin=GizmoBoxYmin, GizmoBoxYmax=GizmoBoxYmax
	NVAR GizmoBoxZmin=GizmoBoxZmin, GizmoBoxZmax=GizmoBoxZmax
	printf "GizmoBox = [%g, %g] [%g, %g] [%g, %g]\r",GizmoBoxXmin, GizmoBoxXmax,GizmoBoxYmin, GizmoBoxYmax,GizmoBoxZmin, GizmoBoxZmax

	Variable GizmoXmin,GizmoXmax, GizmoYmin,GizmoYmax, GizmoZmin,GizmoZmax
	getGizmoDataLimits(GizmoXmin,GizmoXmax, GizmoYmin,GizmoYmax, GizmoZmin,GizmoZmax)
	printf "Gizmo Data = [%g, %g] [%g, %g] [%g, %g]\r",GizmoXmin, GizmoXmax,GizmoYmin, GizmoYmax,GizmoZmin, GizmoZmax

	Variable zoom,xc,yc,zc, xhw,yhw,zhw
	getGizmoCurrentZoomCent(zoom,xc,yc,zc, xhw,yhw,zhw)
	printf "center offset = {%g, %g, %g},   half-widths = {%g, %g, %g}\r",xc,yc,zc,xhw,yhw,zhw
	SetDataFolder fldrSav
End


Function translateGizmo(dx,dy,dz)
	Variable dx,dy,dz
	if (itemsInList(WinList("*",";","WIN:4096"))==0)
		return 1
	endif

	if (numtype(dx+dy+dz))
		Execute/Z/Q "ModifyGizmo autoScale"
		return 0
	endif

	Variable Xmin,Xmax, Ymin,Ymax, Zmin,Zmax
	getGizmoDataLimits(Xmin,Xmax, Ymin,Ymax, Zmin,Zmax)
	Variable XminB, XmaxB, YminB, YmaxB, ZminB, ZmaxB
	getGizmoCurrentBox(XminB, XmaxB, YminB, YmaxB, ZminB, ZmaxB)

	dx -= (XminB+XmaxB)/2 - (Xmin+Xmax)/2
	dy -= (YminB+YmaxB)/2 - (Ymin+Ymax)/2
	dz -= (ZminB+ZmaxB)/2 - (Zmin+Zmax)/2
	Execute "ModifyGizmo scalingOption=0"
	String cmd
	sprintf cmd "ModifyGizmo setOuterBox={%g,%g,%g,%g,%g,%g}",XminB+dx,XmaxB+dx, YminB+dy,YmaxB+dy, ZminB+dz,ZmaxB+dz
	Execute cmd
	Execute "ModifyGizmo scalingMode=8"
End


Function zoomGizmo(zoom)
	Variable zoom
	if (itemsInList(WinList("*",";","WIN:4096"))==0)
		return 1
	endif

	if (zoom<=0 || numtype(zoom))
		Execute/Z/Q "ModifyGizmo autoScale"
		return 0
	endif

	Variable Xmin,Xmax, Ymin,Ymax, Zmin,Zmax
	getGizmoDataLimits(Xmin,Xmax, Ymin,Ymax, Zmin,Zmax)

	Variable XminB, XmaxB, YminB, YmaxB, ZminB, ZmaxB
	getGizmoCurrentBox(XminB, XmaxB, YminB, YmaxB, ZminB, ZmaxB)

	Variable xc=(XmaxB+XminB)/2, yc=(YmaxB+YminB)/2, zc=(ZmaxB+ZminB)/2
	Variable xWidth=Xmax-Xmin, yWidth=Ymax-Ymin, zWidth=Zmax-Zmin
	Variable dx = zoom*xWidth/2, dy = zoom*yWidth/2, dz = zoom*zWidth/2

	Execute "ModifyGizmo scalingOption=0"
	String cmd
	sprintf cmd "ModifyGizmo setOuterBox={%g,%g,%g,%g,%g,%g}",xc-dx, xc+dx, yc-dy, yc+dy, zc-dz, zc+dz
	Execute cmd
	Execute "ModifyGizmo scalingMode=8"
	//	ModifyGizmo scalingMode=8
	//	ModifyGizmo ScalingMode=2
End


Static Function GizmoZoomTranslateUpdateHook(s)
	STRUCT WMWinHookStruct &s

	Variable hookResult = 0
	switch(s.eventCode)
		case 0:				// Activate
		case 6:				// resize
		case 12:			// moved
			Variable zoom,xc,yc,zc, v
			hookResult = !getGizmoCurrentZoomCent(zoom,xc,yc,zc,v,v,v)
			SetVariable zoomVal,value= _NUM:zoom
			SetVariable xTranslate,value= _NUM:xc
			SetVariable yTranslate,value= _NUM:yc
			SetVariable zTranslate,value= _NUM:zc
			break
	endswitch
	return hookResult		// 0 if nothing done, else 1
End
//
Static Function GizmoZoomTranslateSetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva

	switch( sva.eventCode )
		case 1: // mouse up
		case 2: // Enter key
			Variable dval = sva.dval
			String ctrlName = sva.ctrlName
			break
		default:
			return 0
	endswitch

	Variable zoom,xc,yc,zc, xhw,yhw,zhw
	getGizmoCurrentZoomCent(zoom,xc,yc,zc,xhw,yhw,zhw)
	strswitch(ctrlName)
		case "zoomVal":
			zoomGizmo(dval)
			break
		case "xTranslate":
			translateGizmo(dval,yc,zc)
			break
		case "yTranslate":
			translateGizmo(xc,dval,zc)
			break
		case "zTranslate":
			translateGizmo(xc,yc,dval)
			break
	endswitch

	return 0
End
//
Static Function GizmoZoomTransButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	if (ba.eventCode != 2)	// mouse up event
		return 0
	elseif (itemsInList(WinList("*",";","WIN:4096"))<1)
		return 0
	endif

	if (stringmatch(ba.ctrlName,"autoButton"))
		Execute/Z/Q "ModifyGizmo scalingOption=0"
		Execute/Z/Q "ModifyGizmo autoScale"
		Variable zoom,xc,yc,zc, xhw,yhw,zhw
		getGizmoCurrentZoomCent(zoom,xc,yc,zc, xhw,yhw,zhw)
		SetVariable zoomVal,value= _NUM:zoom
		SetVariable xTranslate,value= _NUM:xc
		SetVariable yTranslate,value= _NUM:yc
		SetVariable zTranslate,value= _NUM:zc
	elseif (stringmatch(ba.ctrlName,"cubifyButton"))
		Variable Xlo,Xhi,Ylo,Yhi,Zlo,Zhi
		getGizmoCurrentBox(Xlo,Xhi,Ylo,Yhi,Zlo,Zhi)
		Variable hw = max(max(Xhi-Xlo,Yhi-Ylo),Zhi-Zlo)/2
		Variable dx,dy,dz
		dx = hw - (Xhi-Xlo)/2
		dy = hw - (Yhi-Ylo)/2
		dz = hw - (Zhi-Zlo)/2
		String cmd
		sprintf cmd "ModifyGizmo setOuterBox={%g,%g,%g,%g,%g,%g}",Xlo-dx,Xhi+dx, Ylo-dy,Yhi+dy, Zlo-dz,Zhi+dz
		Execute cmd
		Execute "ModifyGizmo scalingMode=8"
	endif

	return 0
End
//
Static Function getGizmoCurrentZoomCent(zoom,xc,yc,zc,xhw,yhw,zhw)
	Variable &zoom, &xc,&yc,&zc, &xhw,&yhw,&zhw
	if (itemsInList(WinList("*",";","WIN:4096"))==0)
		zoom = NaN
		xc = NaN
		yc = NaN
		zc = NaN
		return 1
	endif

	Variable Xmin,Xmax, Ymin,Ymax, Zmin,Zmax
	getGizmoDataLimits(Xmin,Xmax, Ymin,Ymax, Zmin,Zmax)
	Variable XminB, XmaxB, YminB, YmaxB, ZminB, ZmaxB
	getGizmoCurrentBox(XminB, XmaxB, YminB, YmaxB, ZminB, ZmaxB)
	zoom = (XmaxB-XminB) / (Xmax-Xmin)
	xc = (XmaxB+XminB)/2 - (Xmax+Xmin)/2
	yc = (YmaxB+YminB)/2 - (Ymax+Ymin)/2
	zc = (ZmaxB+ZminB)/2 - (Zmax+Zmin)/2
	xhw = (XmaxB-XminB)/2
	yhw = (YmaxB-YminB)/2
	zhw = (ZmaxB-ZminB)/2
	return 0
End
//
Static Function getGizmoCurrentBox(Xlo,Xhi,Ylo,Yhi,Zlo,Zhi)
	Variable &Xlo,&Xhi,&Ylo,&Yhi,&Zlo,&Zhi

	String fldrSav= GetDataFolder(1)
	SetDataFolder root:Packages:GizmoZoomTranslate
	Execute "GetGizmo userBoxLimits"
	SetDataFolder fldrSav
	Xlo = NumVarOrDefault("root:Packages:GizmoZoomTranslate:GizmoBoxXmin",NaN)
	Xhi = NumVarOrDefault("root:Packages:GizmoZoomTranslate:GizmoBoxXmax",NaN)
	Ylo = NumVarOrDefault("root:Packages:GizmoZoomTranslate:GizmoBoxYmin",NaN)
	Yhi = NumVarOrDefault("root:Packages:GizmoZoomTranslate:GizmoBoxYmax",NaN)
	Zlo = NumVarOrDefault("root:Packages:GizmoZoomTranslate:GizmoBoxZmin",NaN)
	Zhi = NumVarOrDefault("root:Packages:GizmoZoomTranslate:GizmoBoxZmax",NaN)
	if (numtype(Xlo+Xhi+Ylo+Yhi+Zlo+Zhi))
		getGizmoDataLimits(Xlo,Xhi,Ylo,Yhi,Zlo,Zhi)	// use full data range if there  are no box values
	endif
End
//
Static Function getGizmoDataLimits(Xlo,Xhi,Ylo,Yhi,Zlo,Zhi)
	Variable &Xlo,&Xhi,&Ylo,&Yhi,&Zlo,&Zhi

	String fldrSav= GetDataFolder(1)
	SetDataFolder root:Packages:GizmoZoomTranslate
	Execute "GetGizmo dataLimits"
	SetDataFolder fldrSav
	Xlo = NumVarOrDefault("root:Packages:GizmoZoomTranslate:GizmoXmin",NaN)
	Xhi = NumVarOrDefault("root:Packages:GizmoZoomTranslate:GizmoXmax",NaN)
	Ylo = NumVarOrDefault("root:Packages:GizmoZoomTranslate:GizmoYmin",NaN)
	Yhi = NumVarOrDefault("root:Packages:GizmoZoomTranslate:GizmoYmax",NaN)
	Zlo = NumVarOrDefault("root:Packages:GizmoZoomTranslate:GizmoZmin",NaN)
	Zhi = NumVarOrDefault("root:Packages:GizmoZoomTranslate:GizmoZmax",NaN)
End

// ************************ End of Zoom/Translate ************************
// ****************************************************************


//Function setGizmoAxisLabels(xlabel,ylabel,zlabel)
//	String xlabel,ylabel,zlabel
//	if (itemsInList(WinList("*",";","WIN:4096"))==0)
//		return 1
//	endif
//
//	Execute "GetGizmo objectItemExists=axes0"
//	NVAR V_Flag=V_Flag
//	if (!V_flag)
//		Execute "AppendToGizmo Axes=boxAxes,name=axes0"
//	endif
//	String cmd
//
//	if (stringmatch(xlabel,"empty"))
//		Execute "ModifyGizmo ModifyObject=axes0,property={0,axisLabel,0}"
//	elseif (strlen(xlabel))
//		Execute "ModifyGizmo ModifyObject=axes0,property={0,ticks,3}"
//		Execute "ModifyGizmo ModifyObject=axes0,property={0,axisLabel,1}"
//		sprintf cmd, "ModifyGizmo ModifyObject=axes0,property={0,axisLabelText,\"%s\"}",xlabel
//		Execute cmd
//		Execute "ModifyGizmo ModifyObject=axes0,property={0,axisLabelDistance,0.05}"
//		Execute "ModifyGizmo ModifyObject=axes0,property={0,axisLabelScale,0.5}"
//	endif
//
//	if (stringmatch(ylabel,"empty"))
//		Execute "ModifyGizmo ModifyObject=axes0,property={1,axisLabel,0}"
//	elseif (strlen(ylabel))
//		Execute "ModifyGizmo ModifyObject=axes0,property={1,ticks,3}"
//		Execute "ModifyGizmo ModifyObject=axes0,property={1,axisLabel,1}"
//		sprintf cmd, "ModifyGizmo ModifyObject=axes0,property={1,axisLabelText,\"%s\"}",ylabel
//		Execute cmd
//		Execute "ModifyGizmo ModifyObject=axes0,property={1,axisLabelDistance,0.05}"
//		Execute "ModifyGizmo ModifyObject=axes0,property={1,axisLabelScale,0.5}"
//	endif
//
//	if (stringmatch(zlabel,"empty"))
//		Execute "ModifyGizmo ModifyObject=axes0,property={2,axisLabel,0}"
//	elseif (strlen(zlabel))
//		Execute "ModifyGizmo ModifyObject=axes0,property={2,ticks,3}"
//		Execute "ModifyGizmo ModifyObject=axes0,property={2,axisLabel,1}"
//		sprintf cmd, "ModifyGizmo ModifyObject=axes0,property={2,axisLabelText,\"%s\"}",zlabel
//		Execute cmd
//		Execute "ModifyGizmo ModifyObject=axes0,property={2,axisLabelDistance,0.2}"
//		Execute "ModifyGizmo ModifyObject=axes0,property={2,axisLabelScale,0.5}"
//	endif
//End


//Function/WAVE MakeGizmocubeCorners(xyz)
//	Wave xyz							// xyz[N][3], or xyz[nx][ny][nz]
//
//	Variable Xlo=NaN, Xhi=NaN, Ylo=NaN, Yhi=NaN, Zlo=NaN, Zhi=NaN
//	if (WaveDims(xyz)==3)				// a scaled 3D array
//		Xlo = DimOffset(xyz,0)
//		Xhi = DimDelta(xyz,0)*(DimSize(xyz,0)-1) + Xlo
//		Ylo = DimOffset(xyz,1)
//		Yhi = DimDelta(xyz,1)*(DimSize(xyz,1)-1) + Ylo
//		Zlo = DimOffset(xyz,2)
//		Zhi = DimDelta(xyz,2)*(DimSize(xyz,2)-1) + Zlo
//		Variable swap
//		if (Xlo>Xhi)
//			swap = Xlo
//			Xlo = Xhi
//			Xhi = swap
//		endif
//		if (Ylo>Yhi)
//			swap = Ylo
//			Ylo = Yhi
//			Yhi = swap
//		endif
//		if (Zlo>Zhi)
//			swap = Zlo
//			Zlo = Zhi
//			Zhi = swap
//		endif
//	else
//		Variable N=DimSize(xyz,0)		// a list of (xyz) triplets
//		Make/N=(N)/FREE/D cubeCorners_All
//		cubeCorners_All = xyz[p][0]
//		WaveStats/Q cubeCorners_All
//		Xlo=V_min; Xhi=V_max
//		cubeCorners_All = xyz[p][1]
//		WaveStats/Q cubeCorners_All
//		Ylo=V_min; Yhi=V_max
//		cubeCorners_All = xyz[p][2]
//		WaveStats/Q cubeCorners_All
//		Zlo=V_min; Zhi=V_max
//	endif
//
//	Variable dX=Xhi-Xlo, dY=Yhi-Ylo, dZ=Zhi-Zlo
//	Variable d = max(max(dX,dY),dZ)/2, mid
//
//	Variable printIt = strlen(GetRTStackInfo(2))<=0
//	if (printIt)
//		printf "X = [%g, %g], 	=%g\r",Xlo,Xhi,dX
//		printf "Y = [%g, %g], 		=%g\r",Ylo,Yhi,dY
//		printf "Z = [%g, %g], 	=%g\r",Zlo,Zhi,dZ
//	endif
//	mid = (Xlo+Xhi)/2;		Xlo = mid-d;	Xhi = mid+d
//	mid = (Ylo+Yhi)/2;		Ylo = mid-d;	Yhi = mid+d
//	mid = (Zlo+zhi)/2;		Zlo = mid-d;	Zhi = mid+d
//	if (printIt)
//		print " "
//		printf "X = [%g, %g], 	=%g\r",Xlo,Xhi,Xhi-Xlo
//		printf "Y = [%g, %g], 		=%g\r",Ylo,Yhi,Yhi-Ylo
//		printf "Z = [%g, %g], 	=%g\r",Zlo,Zhi,Zhi-Zlo
//	endif
//
//	String name=CleanupName(NameOfWave(xyz)+"Corners",0)
//	Make/N=(8,3)/O $name=NaN
//	Wave corners = $name
//	corners[0][0] = Xlo;	corners[0][1] = Ylo; 	corners[0][2] = Zlo
//	corners[1][0] = Xhi;	corners[1][1] = Ylo; 	corners[1][2] = Zlo
//	corners[2][0] = Xlo;	corners[2][1] = Yhi; 	corners[2][2] = Zlo
//	corners[3][0] = Xhi;	corners[3][1] = Yhi; 	corners[3][2] = Zlo
//	corners[4][0] = Xlo;	corners[4][1] = Ylo; 	corners[4][2] = Zhi
//	corners[5][0] = Xhi;	corners[5][1] = Ylo; 	corners[5][2] = Zhi
//	corners[6][0] = Xlo;	corners[6][1] = Yhi; 	corners[6][2] = Zhi
//	corners[7][0] = Xhi;	corners[7][1] = Yhi; 	corners[7][2] = Zhi
//	String wnote="waveClass=GizmoCorners;"
//	wnote = ReplaceStringByKey("sourceWave",wnote,NameOfWave(xyz),"=")
//	Note/K corners, wnote
//	return corners
//End


Function InitGizmoZoomTranslate()
	Execute/Q/Z "GizmoMenu AppendItem={JZT1,\"Zoom & Translate\", \"MakeGizmoZoomTransPanel()\"}"
	Execute/Q/Z "GizmoMenu AppendItem={JZT2,\"Marker Panel\", \"MakeGizmoScatterMarkerPanel()\"}"
	Execute/Q/Z "GizmoMenu AppendItem={JZT3,\"Cut Plane\", \"MakeGizmoCutPlanePanel()\"}"
	Execute/Q/Z "GizmoMenu AppendItem={JZT4,\"  Gizmo X-H plane\", \"ModifyGizmo stopRotation ; ModifyGizmo SETQUATERNION={0,0,0,1}\"}"	// X-H
	Execute/Q/Z "GizmoMenu AppendItem={JZT5,\"  Gizmo X-F plane\", \"ModifyGizmo stopRotation ; ModifyGizmo SETQUATERNION={0.707106781186547,0,0,0.707106781186547}\"}"	// X-F
//	Execute/Q/Z "GizmoMenu AppendItem={JZT6,\"  Gizmo H-F plane\", \"ModifyGizmo stopRotation ; ModifyGizmo SETQUATERNION={0.5,-0.5,-0.5,0.5}\"}"	// H-F
	Execute/Q/Z "GizmoMenu AppendItem={JZT7,\"  Gizmo H-F plane\", \"ModifyGizmo stopRotation ; ModifyGizmo SETQUATERNION={0.5,0.5,0.5,0.5}\"}"	// H-F
	Execute/Q/Z "GizmoMenu AppendItem={JZT7,\"  Gizmo Beamline\", \"ModifyGizmo stopRotation ; ModifyGizmo SETQUATERNION={-0.270598,0.653282,-0.270598,0.653281}\"}"	// ModifyGizmo euler={0,-90,45}
	NewDataFolder/O root:Packages
	NewDataFolder/O root:Packages:GizmoZoomTranslate
End



